/*!
 * MediaElement.js
 * http://www.mediaelementjs.com/
 *
 * Wrapper that mimics native HTML5 MediaElement (audio and video)
 * using a variety of technologies (pure JavaScript, Flash, iframe)
 *
 * Copyright 2010-2017, John Dyer (http://j.hn/)
 * License: MIT
 *
 */
!function n(a,o,r){function p(e,t){if(!o[e]){if(!a[e]){var l="function"==typeof require&&require;if(!t&&l)return l(e,!0);if(c)return c(e,!0);var s=new Error("Cannot find module '"+e+"'");throw s.code="MODULE_NOT_FOUND",s}var i=o[e]={exports:{}};a[e][0].call(i.exports,function(t){return p(a[e][1][t]||t)},i,i.exports,n,a,o,r)}return o[e].exports}for(var c="function"==typeof require&&require,t=0;t<r.length;t++)p(r[t]);return p}({1:[function(t,e,l){"use strict";mejs.i18n.en["mejs.playlist"]="Toggle Playlist",mejs.i18n.en["mejs.playlist-prev"]="Previous",mejs.i18n.en["mejs.playlist-next"]="Next",mejs.i18n.en["mejs.playlist-loop"]="Loop",mejs.i18n.en["mejs.playlist-shuffle"]="Shuffle",Object.assign(mejs.MepDefaults,{playlist:[],showPlaylist:!0,autoClosePlaylist:!1,prevText:null,nextText:null,loopText:null,shuffleText:null,playlistTitle:null,currentMessage:null}),Object.assign(MediaElementPlayer.prototype,{buildplaylist:function(a,t,e,l){var s=mejs.i18n.t("mejs.playlist"),i=mejs.Utils.isString(a.options.playlistTitle)?a.options.playlistTitle:s;if(!a.createPlayList_()){if(a.currentPlaylistItem=0,a.originalControlsIndex=t.style.zIndex,t.style.zIndex=5,a.endedCallback=function(){a.currentPlaylistItem<a.listItems.length&&(a.setSrc(a.playlist[++a.currentPlaylistItem]),a.load(),setTimeout(function(){a.play()},200))},l.addEventListener("ended",a.endedCallback),!a.isVideo){var n=document.createElement("div"),o=function(){n.innerHTML="",void 0!==a.playlist[a.currentPlaylistItem]["data-playlist-thumbnail"]&&(n.innerHTML+='<img tabindex="-1" src="'+a.playlist[a.currentPlaylistItem]["data-playlist-thumbnail"]+'">'),n.innerHTML+="<p>"+(a.options.currentMessage||"")+' <span class="'+a.options.classPrefix+'playlist-current-title">'+a.playlist[a.currentPlaylistItem].title+"</span>",void 0!==a.playlist[a.currentPlaylistItem].description&&(n.innerHTML+=' - <span class="'+a.options.classPrefix+'playlist-current-description">'+a.playlist[a.currentPlaylistItem].description+"</span>"),n.innerHTML+="</p>",a.resetSize()};n.className=a.options.classPrefix+"playlist-current "+a.options.classPrefix+"layer",o(),e.insertBefore(n,e.firstChild),l.addEventListener("play",o)}if(a.options.showPlaylist){a.playlistLayer=document.createElement("div"),a.playlistLayer.className=a.options.classPrefix+"playlist-layer  "+a.options.classPrefix+"layer "+(a.isVideo?a.options.classPrefix+"playlist-hidden":"")+" "+a.options.classPrefix+"playlist-selector",a.playlistLayer.innerHTML='<ul class="'+a.options.classPrefix+'playlist-selector-list"></ul>',e.insertBefore(a.playlistLayer,e.firstChild);for(var r=0,p=a.listItems.length;r<p;r++)a.playlistLayer.querySelector("ul").innerHTML+=a.listItems[r];if(a.isVideo)a.playlistButton=document.createElement("div"),a.playlistButton.className=a.options.classPrefix+"button "+a.options.classPrefix+"playlist-button",a.playlistButton.innerHTML='<button type="button" aria-controls="'+a.id+'" title="'+i+'" aria-label="'+i+'" tabindex="0"></button>',a.playlistButton.addEventListener("click",function(){mejs.Utils.toggleClass(a.playlistLayer,a.options.classPrefix+"playlist-hidden")}),a.addControlElement(a.playlistButton,"playlist");else{var c=a.playlistLayer.querySelectorAll("li");if(c.length<=10){for(var u=0,f=0,y=c.length;f<y;f++)u+=c[f].offsetHeight;a.container.style.height=u+"px"}}for(var d=a.playlistLayer.querySelectorAll("."+a.options.classPrefix+"playlist-selector-list-item"),m=a.playlistLayer.querySelectorAll("input[type=radio]"),v=0,x=m.length;v<x;v++)m[v].disabled=!1,m[v].addEventListener("click",function(){for(var t=a.playlistLayer.querySelectorAll('input[type="radio"]'),e=a.playlistLayer.querySelectorAll("."+a.options.classPrefix+"playlist-selected"),l=0,s=t.length;l<s;l++)t[l].checked=!1;for(var i=0,n=e.length;i<n;i++)mejs.Utils.removeClass(e[i],a.options.classPrefix+"playlist-selected"),e[i].querySelector("label").querySelector("span").remove();this.checked=!0,this.closest("."+a.options.classPrefix+"playlist-selector-list-item").querySelector("label").innerHTML="<span>▶</span> "+this.closest("."+a.options.classPrefix+"playlist-selector-list-item").querySelector("label").innerHTML,mejs.Utils.addClass(this.closest("."+a.options.classPrefix+"playlist-selector-list-item"),a.options.classPrefix+"playlist-selected"),a.currentPlaylistItem=this.getAttribute("data-playlist-index"),a.setSrc(this.value),a.load(),a.play(),a.isVideo&&!0===a.options.autoClosePlaylist&&mejs.Utils.toggleClass(a.playlistLayer,a.options.classPrefix+"playlist-hidden")});for(var h=0,P=d.length;h<P;h++)d[h].addEventListener("click",function(){var t=mejs.Utils.siblings(this.querySelector("."+a.options.classPrefix+"playlist-selector-label"),function(t){return"INPUT"===t.tagName})[0],e=mejs.Utils.createEvent("click",t);t.dispatchEvent(e)});a.keydownCallback=function(t){var e=mejs.Utils.createEvent("click",t.target);return t.target.dispatchEvent(e),!1},a.playlistLayer.addEventListener("keydown",function(t){var e=t.which||t.keyCode||0;~[13,32,38,40].indexOf(e)&&a.keydownCallback(t)})}else mejs.Utils.addClass(a.container,a.options.classPrefix+"no-playlist")}},cleanplaylist:function(t,e,l,s){s.removeEventListener("ended",t.endedCallback)},buildprevtrack:function(t){var e=mejs.i18n.t("mejs.playlist-prev"),l=mejs.Utils.isString(t.options.prevText)?t.options.prevText:e;t.prevButton=document.createElement("div"),t.prevButton.className=t.options.classPrefix+"button "+t.options.classPrefix+"prev-button",t.prevButton.innerHTML='<button type="button" aria-controls="'+t.id+'" title="'+l+'" aria-label="'+l+'" tabindex="0"></button>',t.prevPlaylistCallback=function(){t.playlist[--t.currentPlaylistItem]?(t.setSrc(t.playlist[t.currentPlaylistItem].src),t.load(),t.play()):++t.currentPlaylistItem},t.prevButton.addEventListener("click",t.prevPlaylistCallback),t.addControlElement(t.prevButton,"prevtrack")},cleanprevtrack:function(t){t.prevButton.removeEventListener("click",t.prevPlaylistCallback)},buildnexttrack:function(t){var e=mejs.i18n.t("mejs.playlist-next"),l=mejs.Utils.isString(t.options.nextText)?t.options.nextText:e;t.nextButton=document.createElement("div"),t.nextButton.className=t.options.classPrefix+"button "+t.options.classPrefix+"next-button",t.nextButton.innerHTML='<button type="button" aria-controls="'+t.id+'" title="'+l+'" aria-label="'+l+'" tabindex="0"></button>',t.nextPlaylistCallback=function(){t.playlist[++t.currentPlaylistItem]?(t.setSrc(t.playlist[t.currentPlaylistItem].src),t.load(),t.play()):--t.currentPlaylistItem},t.nextButton.addEventListener("click",t.nextPlaylistCallback),t.addControlElement(t.nextButton,"nexttrack")},cleannexttrack:function(t){t.nextButton.removeEventListener("click",t.nextPlaylistCallback)},buildloop:function(t){var e=mejs.i18n.t("mejs.playlist-loop"),l=mejs.Utils.isString(t.options.loopText)?t.options.loopText:e;t.loopButton=document.createElement("div"),t.loopButton.className=t.options.classPrefix+"button "+t.options.classPrefix+"loop-button "+(t.options.loop?t.options.classPrefix+"loop-on":t.options.classPrefix+"loop-off"),t.loopButton.innerHTML='<button type="button" aria-controls="'+t.id+'" title="'+l+'" aria-label="'+l+'" tabindex="0"></button>',t.loopCallback=function(){t.options.loop=!t.options.loop,t.options.loop?(mejs.Utils.removeClass(t.loopButton,t.options.classPrefix+"loop-off"),mejs.Utils.addClass(t.loopButton,t.options.classPrefix+"loop-on")):(mejs.Utils.removeClass(t.loopButton,t.options.classPrefix+"loop-on"),mejs.Utils.addClass(t.loopButton,t.options.classPrefix+"loop-off"))},t.loopButton.addEventListener("click",t.loopCallback),t.addControlElement(t.loopButton,"loop")},cleanloop:function(t){t.loopButton.removeEventListener("click",t.loopCallback)},buildshuffle:function(e){var t=mejs.i18n.t("mejs.playlist-shuffle"),l=mejs.Utils.isString(e.options.shuffleText)?e.options.shuffleText:t;e.shuffleButton=document.createElement("div"),e.shuffleButton.className=e.options.classPrefix+"button "+e.options.classPrefix+"shuffle-button "+e.options.classPrefix+"shuffle-off",e.shuffleButton.innerHTML='<button type="button" aria-controls="'+e.id+'" title="'+l+'" aria-label="'+l+'" tabindex="0"></button>',e.shuffleButton.style.display="none",e.media.addEventListener("play",function(){e.shuffleButton.style.display="",e.resetSize()});var s=!1,i=[],n=function(){if(!e.options.loop){var t=Math.floor(Math.random()*e.playlist.length);-1===i.indexOf(t)?(e.setSrc(e.playlist[t].src),e.load(),e.play(),e.currentPlaylistItem=t,i.push(t)):i.length<e.playlist.length?e.shuffleCallback():i.length<e.playlist.length&&(i=[],e.currentPlaylistItem=t,i.push(t))}};e.shuffleCallback=function(){s?(mejs.Utils.removeClass(e.shuffleButton,e.options.classPrefix+"shuffle-on"),mejs.Utils.addClass(e.shuffleButton,e.options.classPrefix+"shuffle-off"),s=!1,e.media.removeEventListener("ended",n)):(mejs.Utils.removeClass(e.shuffleButton,e.options.classPrefix+"shuffle-off"),mejs.Utils.addClass(e.shuffleButton,e.options.classPrefix+"shuffle-on"),s=!0,e.media.addEventListener("ended",n))},e.shuffleButton.addEventListener("click",e.shuffleCallback),e.addControlElement(e.shuffleButton,"shuffle")},cleanshuffle:function(t){t.shuffleButton.removeEventListener("click",t.shuffleCallback)},createPlayList_:function(){var t=this;if(t.playlist=t.options.playlist.length?t.options.playlist:t.mediaFiles&&t.mediaFiles.length?t.mediaFiles:[],!t.playlist.length)for(var e=t.media.originalNode.children,l=0,s=e.length;l<s;l++){var i=e[l];"source"===i.tagName.toLowerCase()&&function(){var e={};Array.prototype.slice.call(i.attributes).forEach(function(t){e[t.name]=t.value}),e.src&&e.type&&e.title&&(e.type=mejs.Utils.formatType(e.src,e.type),t.playlist.push(e))}()}if(!(t.playlist.length<2)){t.listItems=[];for(var n=0,a=t.playlist.length;n<a;n++){var o=t.playlist[n],r=document.createElement("li"),p=t.id+"_playlist_item_"+n,c=o["data-playlist-thumbnail"]?'<div class="'+t.options.classPrefix+'playlist-item-thumbnail"><img tabindex="-1" src="'+o["data-playlist-thumbnail"]+'"></div>':"",u=o["data-playlist-description"]?'<div class="'+t.options.classPrefix+'playlist-item-description">'+o["data-playlist-description"]+"</div>":"";r.tabIndex=0,r.className=t.options.classPrefix+"playlist-selector-list-item"+(0===n?" "+t.options.classPrefix+"playlist-selected":""),r.innerHTML='<div class="'+t.options.classPrefix+'playlist-item-inner">'+c+'<div class="'+t.options.classPrefix+'playlist-item-content"><div><input type="radio" class="'+t.options.classPrefix+'playlist-selector-input" name="'+t.id+'_playlist" id="'+p+'" data-playlist-index="'+n+'" value="'+o.src+'" disabled><label class="'+t.options.classPrefix+'playlist-selector-label" for="'+p+'">'+(0===n?"<span>▶</span> ":"")+(o.title||n)+"</label></div>"+u+"</div></div>",t.listItems.push(r.outerHTML)}}}})},{}]},{},[1]);